const DEFAULT_WORKER_URL = 'https://panda-water.cn/web4/framework/4.9/';
const gisConfig = {
  baseURL: DEFAULT_WORKER_URL,
  url: DEFAULT_WORKER_URL + 'init.js',
  css: DEFAULT_WORKER_URL + 'gis/css/main.css',
  dojoConfig: {
    has: {
      'gis-featurelayer-webgl': 1,
    },
    aliases: [
      [
        /^webgl-engine/,
        function () {
          return 'gis/views/3d/webgl-engine';
        },
      ],
      [
        /^engine/,
        function () {
          return 'gis/views/3d/webgl-engine';
        },
      ],
      [
        /^gis-hydra/,
        function () {
          return 'gis';
        },
      ],
      ['text', 'dojo/text'],
    ],
    async: 1,
    async: 1,
    baseUrl: './',
    packages: [
      {
        location: DEFAULT_WORKER_URL + 'dojo',
        name: 'dojo',
      },
      {
        location: DEFAULT_WORKER_URL + 'dijit',
        name: 'dijit',
      },
      {
        location: DEFAULT_WORKER_URL + 'dojox',
        name: 'dojox',
      },
      {
        location: DEFAULT_WORKER_URL + 'dgrid',
        main: 'OnDemandGrid',
        name: 'dgrid',
      },
      {
        location: DEFAULT_WORKER_URL + 'dstore',
        main: 'Store',
        name: 'dstore',
      },
      {
        location: DEFAULT_WORKER_URL + 'gis',
        name: 'gis',
      },
      {
        location: DEFAULT_WORKER_URL + 'moment',
        main: 'moment',
        name: 'moment',
      },
      {
        location: DEFAULT_WORKER_URL + '@dojo',
        name: '@dojo',
      },
      {
        location: DEFAULT_WORKER_URL + 'cldrjs',
        main: 'dist/cldr',
        name: 'cldrjs',
      },
      {
        location: DEFAULT_WORKER_URL + 'globalize',
        main: 'dist/globalize',
        name: 'globalize',
      },
      {
        location: DEFAULT_WORKER_URL + 'maquette',
        main: 'dist/maquette.umd',
        name: 'maquette',
      },
      {
        location: DEFAULT_WORKER_URL + 'maquette-css-transitions',
        main: 'dist/maquette-css-transitions.umd',
        name: 'maquette-css-transitions',
      },
      {
        location: DEFAULT_WORKER_URL + 'maquette-jsx',
        main: 'dist/maquette-jsx.umd',
        name: 'maquette-jsx',
      },
      {
        location: DEFAULT_WORKER_URL + 'tslib',
        main: 'tslib',
        name: 'tslib',
      },
    ],
    hasCache: {
      'config-deferredInstrumentation': 0,
      'config-selectorEngine': 'acme',
      'config-tlmSiblingOfDojo': 1,
      'dojo-built': 1,
      'dojo-has-api': 1,
      'dojo-loader': 1,
      'dojo-undef-api': 0,
      dom: 1,
      'host-browser': 1,
      'gis-built': 1,
      'gis-featurelayer-webgl': 0,
      'gis-promise-compatibility': !1,
      'gis-promise-compatibility-deprecation-warnings': !1,
    },
    map: {
      globalize: {
        cldr: 'cldrjs/dist/cldr',
        'cldr/event': 'cldrjs/dist/cldr/event',
        'cldr/supplemental': 'cldrjs/dist/cldr/supplemental',
        'cldr/unresolved': 'cldrjs/dist/cldr/unresolved',
      },
    },
  },
};

export default gisConfig;
