import gisConfig from '../config/gis';
import esriLoader from 'esri-loader';
const loadedModules = {}; //已经加载的模块

const loadMapModules = async (modules) => {
  let needLoadModules = isNeedRequest(modules);
  if (Object.keys(needLoadModules).length > 0) {
    let moduleArr = Object.entries(needLoadModules);
    let moduleUrlsArray = moduleArr.map((item) => item[1]);
    let requestloadedModules = await esriLoader.loadModules(moduleUrlsArray, gisConfig);
    requestloadedModules.map((item, index) => {
      loadedModules[moduleArr[index][0]] = item;
    });
  }
  return loadedModules;
};

const isNeedRequest = (modules) => {
  let needLoadModules = {};
  for (let key in modules) {
    if (!loadedModules[key]) needLoadModules[key] = modules[key];
  }
  return needLoadModules;
};

const getMapModules = () => {
  return loadedModules;
};

export { getMapModules, loadMapModules };
