function loadScripts(srcs) {
  return new Promise((resolve, reject) => {
    if (srcs && srcs.length > 0) {
      var scriptOrLink;
      var _src = srcs.shift();
      if (_src) {
        var isCSS = _src.lastIndexOf('.css') == _src.length - 4;
        if (isCSS) {
          scriptOrLink = document.createElement('link');
          scriptOrLink.type = 'text/css';
          scriptOrLink.rel = 'stylesheet';
          scriptOrLink.href = _src;
        } else {
          scriptOrLink = document.createElement('script');
          scriptOrLink.type = 'text/javascript';
          scriptOrLink.charset = 'utf-8';
          scriptOrLink.src = _src;
        }
        if (scriptOrLink) {
          scriptOrLink.onload = function () {
            if (srcs.length > 0) {
              loadScripts(srcs).then(resolve, reject);
            } else {
              resolve();
            }
          };
          scriptOrLink.onerror = reject;
          document.getElementsByTagName('head')[0].appendChild(scriptOrLink);
        }
      }
    }
  });
}

export default loadScripts;
