import mapsettings from '../mapData';
import MapView from '../index';

export default class CreateMap extends React.Component {
  constructor(props) {
    super(props);
    this.mapManganerRef = React.createRef();
    // if (!window._config) {
    //   window._config = {
    //     site: '',
    //     useCoverMap: true,
    //   };
    // }
  }

  state = {
    loaded: false,
    mapsettings: null,
  };

  componentDidMount() {
    let url = location.origin + '/CityInterface/rest/services.svc/GetWebSiteConfig?client=city';
    fetch(url)
      .then((data) => data.json())
      .then((response) => {
        let data = response[0]['mapsettings'];
        this.handleData(data);
        this.setState({
          mapsettings: data,
          loaded: true,
        });
      })
      .catch(() => {
        new Error('请求资源失败');
      });
  }

  handleData = (data) => {
    let areasettings = data.areasettings;
    let layer = data.layers && data.layers[0];
    if (layer) {
      areasettings.areaName = layer.areaName ? layer.areaName : areasettings.areaName;
      areasettings.backgroundColor = layer.backgroundColor
        ? layer.backgroundColor
        : areasettings.backgroundColor;
      areasettings.backgroundOpacity = layer.backgroundOpacity
        ? layer.backgroundOpacity
        : areasettings.backgroundOpacity;
      areasettings.boundColor = layer.boundColor ? layer.boundColor : areasettings.boundColor;
      areasettings.boundWidth = layer.boundWidth ? layer.boundWidth : areasettings.boundWidth;
      areasettings.extent = layer.extent ? layer.extent : areasettings.extent;
      data.basemaps = layer.basemaps ? layer.basemaps : data.basemaps;
    }
  };

  render() {
    const { loaded, mapsettings } = this.state;
    return (
      <>
        {loaded ? (
          <MapView mapsettings={mapsettings} ref={this.mapManganerRef} />
        ) : (
          <div>
            <h1>加载中.....</h1>
          </div>
        )}
      </>
    );
  }
}
