import TilemetaUtils from './support/TilemetaUtils';
import { getMapModules } from '../../core/loadMapModules';
//百度地图
export default function ({ TileLayer, promiseUtils } = getMapModules()) {
  var dpi = 96, //pixel per inch
    level = 99, //地图缩放级数
    maxlevel = 20, //地图总级数
    levelStart = 5, // 起始级数
    resolution_0 = 262144, //第0级分辨率 米/像素
    tileSize = 256, //瓦片大小
    format = 'PNG', //图片格式
    wkid = 4526, //102100
    fullExtent = [3471225.2442693943, 685702.9352539922, 19199896.701612312, 7935637.435122993], //[-33554432,-33554432,33554432,33554432]
    origin = { x: -33554432, y: 33554432 }, //裁图原点
    ak = 'E4805d16520de693a3fe707cdc962045',
    defaultStyles =
      't:all|e:all|l:13|s:-51,t:road|e:all|l:39|s:-60,t:all|e:l.i|l:22|s:-100|h:#000000',
    server = {
      //出图服务参数
      count: 10, //服务总数
      start: 0, //服务起始编号
      seq: 0, //当前请求编号
      //矢量
      'baidu-v':
        window.location.protocol +
        '//api<%=num%>.map.bdimg.com/customimage/tile?x=<%=col%>&y=<%=row%>&z=<%=level%>&scale=<%=scale%>&ak=<%=ak%>&styles=<%=styles%>&type=map',
      //影像
      'baidu-i':
        window.location.protocol +
        '//shangetu<%=num%>.map.bdimg.com/it/u=x=<%=col%>;y=<%=row%>;z=<%=level%>;v=009;type=sate&fm=46&type=map',
      //影像注记
      'baidu-ia':
        window.location.protocol +
        '//online<%=num%>.map.bdimg.com/onlinelabel/?qt=tile&x=<%=col%>&y=<%=row%>&z=<%=level%>&styles=sl&type=map',
    };

  return TileLayer.createSubclass([], {
    declaredClass: 'gis.layers.BaiduTileLayer',
    _fetchService: function () {
      //重写 获取元数据，读取本地TileMetaData
      this.isVector() && (server.count = 3);
      return promiseUtils.resolve().then(
        function () {
          this.read(
            TilemetaUtils.getTilemeta(
              resolution_0,
              dpi,
              level,
              levelStart,
              wkid,
              fullExtent,
              origin,
              tileSize,
              format,
            ),
          );
        }.bind(this),
      );
    },
    getTileUrl: function (level, row, col) {
      //重写 获取瓦片服务地址
      var tileCount = parseInt(Math.pow(2, level)),
        col = col - tileCount / 2,
        row = tileCount / 2 - row - 1;
      server.seq++, (server.seq %= server.count);
      return maxlevel < level
        ? null
        : _.template(this.getServerUrl())({
            num: server.seq + server.start,
            row: row,
            col: col,
            level: level,
            scale: window.devicePixelRatio,
            styles: encodeURIComponent(this.url || defaultStyles),
            ak: ak,
          });
    },
    isVector: function () {
      return this.layerType == 'baidu-v';
    },
    getServerUrl: function () {
      var serverUrl = server[this.layerType];
      return serverUrl;
    },
  });
}
