import { getMapModules } from '../../core/loadMapModules';

export default function ({ config, WebTileLayer } = getMapModules()) {
  let a = config,
    b = WebTileLayer;
  a.request.corsEnabledServers.push('a.tile.mapbox.org', 'b.tile.mapbox.org', 'c.tile.mapbox.org');
  return b.createSubclass({
    declaredClass: 'gis.layers.MapBoxLayer',
    properties: {
      copyright: 'Map data \x26copy; mapbox contributors, CC-BY-SA',
      subDomains: { value: ['a', 'b', 'c'] },
      urlTemplate:
        'https://{subDomain}.tiles.mapbox.com/v4/mapbox.streets-basic/{level}/{col}/{row}.png?access_token=pk.eyJ1IjoibWFwYm94IiwiYSI6ImNpejY4M29iazA2Z2gycXA4N2pmbDZmangifQ.-g_vE53SD2WrJ6tFX7QHmA',
      operationalLayerType: 'mapbox',
      type: { value: 'mapbox', json: { read: !1 } },
    },
  });
}
