// 天地图 (由TileLayer扩展)
// create by czl 2017/12/2
import TilemetaUtils from './support/TilemetaUtils';
import { getMapModules } from '../../core/loadMapModules';

export default function ({ TileLayer, lang, promiseUtils } = getMapModules()) {
  var dpi = 96, //pixel per inch
    level = 20, //地图总级数
    levelStart = 3, // 起始级数
    // levelStart = 11, // 起始级数
    resolution_0 = 156543.0339280234, //第0级分辨率 米/像素
    tileSize = 256, //瓦片大小
    format = 'PNG', //图片格式
    wkid = 4526, //102113
    fullExtent = [705289.3147226945, 206299.30564637203, 19490490.956488788, 8865103.18739793], //[-20037508.3427892,-20037508.3427892,20037508.3427892,20037508.3427892]
    origin = {
      x: -20037508.3427892,
      y: 20037508.3427892,
    }, //裁图原点
    wkid_ll = 4490,
    resolution_0_ll = 0.703125,
    // resolution_0_jn = 1.4881889763779584,
    resolution_0_jn = 0.143984375,
    fullExtent_jn = [-30.85, 60.594, -30.354, 61.327],
    fullExtent_ll = [
      -31.904360683593602,
      60.32192850494357,
      -29.267636660156114,
      61.62381099151584,
    ],
    // fullExtent_ll = [-57.854119614257556, 53.119002722167735, -15.666535239257712, 72.56484239501923],
    origin_ll = {
      x: -180,
      y: 90,
    },
    server = {
      //出图服务参数
      count: 3, //服务总数
      start: 0, //服务起始编号
      seq: 0, //当前请求编号
      //球形墨卡托
      //矢量
      'tianditu-v':
        window.location.protocol +
        '//t{num}.tianditu.com/DataServer?T=vec_w&x={col}&y={row}&l={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //矢量注记
      'tianditu-va':
        window.location.protocol +
        '//t{num}.tianditu.com/DataServer?T=cva_w&x={col}&y={row}&l={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //影像
      'tianditu-i':
        window.location.protocol +
        '//t{num}.tianditu.com/DataServer?T=img_w&x={col}&y={row}&l={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //影像注记
      'tianditu-ia':
        window.location.protocol +
        '//t{num}.tianditu.com/DataServer?T=cia_w&x={col}&y={row}&l={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //地形
      'tianditu-t':
        window.location.protocol +
        '//t{num}.tianditu.com/DataServer?T=ter_w&x={col}&y={row}&l={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //地形注记
      'tianditu-ta':
        window.location.protocol +
        '//t{num}.tianditu.com/DataServer?T=cta_w&x={col}&y={row}&l={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',

      //经纬度
      //矢量
      'tianditu-ll-v':
        window.location.protocol +
        '//t{num}.tianditu.com/vec_c/wmts/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=tiles&serviceMode=KVP&layer=vec&TileMatrixSet=c&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //矢量注记
      'tianditu-ll-va':
        window.location.protocol +
        '//t{num}.tianditu.com/cva_c/wmts/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=tiles&serviceMode=KVP&layer=cva&TileMatrixSet=c&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //影像
      'tianditu-ll-i':
        window.location.protocol +
        '//t{num}.tianditu.com/img_c/wmts/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=tiles&serviceMode=KVP&layer=img&TileMatrixSet=c&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //影像注记
      'tianditu-ll-ia':
        window.location.protocol +
        '//t{num}.tianditu.com/cia_c/wmts/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=tiles&serviceMode=KVP&layer=cia&TileMatrixSet=c&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //地形
      'tianditu-ll-t':
        window.location.protocol +
        '//t{num}.tianditu.com/ter_c/wmts/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=tiles&serviceMode=KVP&layer=ter&TileMatrixSet=c&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //地形注记
      'tianditu-ll-ta':
        window.location.protocol +
        '//t{num}.tianditu.com/cta_c/wmts/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=tiles&serviceMode=KVP&layer=cta&TileMatrixSet=c&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //江宁图层
      'tianditu-jn-jn':
        window.location.protocol +
        '//58.213.148.61:8083/GZ_DT_9_20/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=image%2Ftile&serviceMode=KVP&layer=gz_dt_9_20&TileMatrixSet=Matrix_gz_dt_9_20_0&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //江宁注记图层
      'tianditu-jn-jna':
        window.location.protocol +
        '//58.213.148.61:8083/GZ_ZJ_9_20/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=image%2Ftile&serviceMode=KVP&layer=gz_zj_9_20&TileMatrixSet=Matrix_gz_zj_9_20_0&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
      //江宁影像
      'tianditu-jn-jni':
        window.location.protocol +
        '//58.213.23.212:7003/NJ_DSX_YX/wmts?Service=WMTS&Request=GetTile&Version=1.0.0&Style=Default&Format=image%2Ftile&serviceMode=KVP&layer=nj_dsx_yx&TileMatrixSet=Matrix_nj_dsx_yx_0&TileRow={row}&TileCol={col}&TileMatrix={level}&type=map&tk=eef0de4d706219489963a14e1c1263bb',
    };

  return TileLayer.createSubclass([], {
    declaredClass: 'gis.layers.TiandituTileLayer',
    _fetchService: function () {
      //重写 获取元数据，读取本地TileMetaData
      return promiseUtils.resolve().then(
        function () {
          var tilemeta =
            this.layerType.indexOf('-ll-') == -1
              ? this.layerType.indexOf('-jn-') == -1
                ? TilemetaUtils.getTilemeta(
                    resolution_0,
                    dpi,
                    level,
                    levelStart,
                    wkid,
                    fullExtent,
                    origin,
                    tileSize,
                    format,
                  )
                : TilemetaUtils.getTilemeta(
                    resolution_0_ll,
                    dpi,
                    level,
                    levelStart,
                    wkid_ll,
                    fullExtent_jn,
                    origin_ll,
                    tileSize,
                    format,
                    true,
                  )
              : TilemetaUtils.getTilemeta(
                  resolution_0_ll,
                  dpi,
                  level,
                  levelStart,
                  wkid_ll,
                  fullExtent_ll,
                  origin_ll,
                  tileSize,
                  format,
                  true,
                );
          this.read(tilemeta);
        }.bind(this),
      );
    },

    getTileUrl: function (level, row, col) {
      //重写 获取瓦片服务地址
      server.seq++, (server.seq %= server.count);
      return lang.replace(server[this.layerType], {
        num: server.seq + server.start,
        row: row,
        col: col,
        level: level,
      });
    },
  });
}
