// create by ysq 2018/11/7
import TilemetaUtils from './support/TilemetaUtils';
import { getMapModules } from '../../core/loadMapModules';

export default function ({ TileLayer, lang, promiseUtils } = getMapModules()) {
  var dpi = 96, //pixel per inch
    level = 19, //地图总级数
    levelStart = 9, // 起始级数
    resolution_0 = 156543.03390625, //第0级分辨率 米/像素
    tileSize = 256, //瓦片大小
    format = 'PNG', //图片格式
    wkid = 4526, //102113
    fullExtent = [705289.3147226945, 206299.30564637203, 19490490.956488788, 8865103.18739793], //
    origin = { x: -20037508.3427892, y: 20037508.3427892 }, //裁图原点
    server =
      '{ip}/gwc/rest/wmts/{name}/EPSG%3A900913/EPSG%3A900913%3A{level}/{row}/{col}?format=image/vnd.jpeg-png&type=map';

  return TileLayer.createSubclass([], {
    declaredClass: 'gis.layers.WMTSTileLayer',
    _fetchService: function () {
      //重写 获取元数据，读取本地TileMetaData
      return promiseUtils.resolve().then(
        function () {
          this.read(
            TilemetaUtils.getTilemeta(
              resolution_0,
              dpi,
              level,
              levelStart,
              wkid,
              fullExtent,
              origin,
              tileSize,
              format,
            ),
          );
        }.bind(this),
      );
    },
    getTileUrl: function (level, row, col) {
      //重写 获取瓦片服务地址
      return lang.replace(server, {
        ip: this.url,
        name: this.title,
        row: row,
        col: col,
        level: level,
        scale: 1,
      });
    },
  });
}
