import { loadMapModules } from '../../core/loadMapModules';
import AMapTileLayer from './AMapTileLayer';
import BaiduTileLayer from './BaiduTileLayer';
import GoogleTileLayer from './GoogleTileLayer';
import MapBoxLayer from './MapBoxLayer';
import PipenetTileLayer from './PipenetTileLayer';
import TiandituTileLayer from './TiandituTileLayer';
import UserTileLayer from './UserTileLayer';
import WMTSTileLayer from './WMTSTileLayer';

const modules = {
  TileLayer: 'gis/layers/TileLayer',
  lang: 'dojo/_base/lang',
  promiseUtils: 'gis/core/promiseUtils',
  config: 'gis/config',
  WebTileLayer: 'gis/layers/WebTileLayer',
  request: 'gis/request',
};

const loadMapLayerModules = async () => {
  await loadMapModules(modules);
};

export {
  loadMapLayerModules,
  AMapTileLayer,
  BaiduTileLayer,
  GoogleTileLayer,
  MapBoxLayer,
  PipenetTileLayer,
  TiandituTileLayer,
  UserTileLayer,
  WMTSTileLayer,
};
